/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.apportal.server.console ;

import java.lang.reflect.Method;
import java.util.*;

import javax.servlet.http.*;

import org.azuki.bean.apportal.AppPortalBean;
import org.azuki.common.console.HtmlFactory;
import org.azuki.common.console.html.Table;
import org.azuki.common.console.html.renderer.NullRenderer;
import org.azuki.common.console.http.HttpResponse;
import org.azuki.common.reflect.Signature;
import org.azuki.common.util.*;
import org.azuki.framework.aop.IPointcut;
import org.azuki.framework.bean.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

final public class AppPortalConsole
{
	final static public String[] tableHeaders = {"Bean", "Method"} ;
	
	final public static void p(AppPortalBean pa, HttpServlet servlet, HttpServletRequest req, HttpServletResponse res)
	throws Exception
	{
		List<List> data = new ArrayList<List>() ;
		
		IMetadata meta = pa.getMetadata() ;
		
		for(IPointcut pc : Bean.getPointcuts(meta.getID()))
		{
			IMetadata tmeta = pc.getTargetMetadata() ; 
			Method[] mths = pc.getSelectedMethods() ;
			
			data.add(ListUtil.toList(Util.oneString(tmeta.getName(), tmeta.getLabel()), mths.length==0 ? null : new Signature(mths[0]))) ;
		}
		
		Table table = HtmlFactory.sortedTable(req, data, tableHeaders) ;
		table.setColumnRenderer(1, new NullRenderer("<i>(undefined)</i>")) ;
		
		HttpResponse.print(res, table) ;
	}
} 