/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.apportal.server.imp ;

import org.azuki.framework.bean.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public class PortalID
{
	final static public char pcutSep = '~' ;
	
	final private Integer bid ;
	final private Integer pid ;
	
	private PortalID(Integer bid, Integer pid)
	{
		this.bid = bid ;
		this.pid = pid ;
	}
	
	final public Integer getBeanID()	 { return bid ; }
	final public Integer getPointcutID() { return pid ; }

	final public String asString(char psep)
	{
		StringBuilder bdr = new StringBuilder() ;
		bdr.append(bid.toString()).append(psep).append(pid) ;
		return bdr.toString() ;
	}
	
	@Override
	final public String toString()
	{
		return asString(pcutSep) ;
	}
	
	/**
	 * STATIC
	 */
	final static public PortalID fromString(String src)
	{
		int idx = src.indexOf(pcutSep) ;
		
		if(idx==-1) return new PortalID(Bean.searchFirst(src, null).getID(), null) ;
		return new PortalID(new Integer(src.substring(0, idx)), new Integer(src.substring(idx+1))) ;
	}
}