package org.azuki.bean.authenticator.editor ;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;

import org.azuki.bean.authenticator.shared.ConstLDAP;
import org.azuki.common.editor.IEditorContext;
import org.azuki.common.editor.basic.AbstractEditor;
import org.azuki.common.editor.jdom.*;
import org.azuki.common.util.JDOMUtil;
import org.azuki.common.util.ListUtil;
import org.azuki.common.widget.JFormPanel;
import org.jdom.Attribute;
import org.jdom.Element;

@SuppressWarnings("serial")
public class LDAPAuthenticatorEditor extends AbstractEditor<IEditorContext>
{

	final static private JDOMElementTableBinding tableBinding
					= JDOMElementTableBinding.create(ConstLDAP.CONTEXT,
										ListUtil.asList(ConstLDAP.TYPE, ConstLDAP.VALUE),
										ListUtil.asList("Type", "Value")) ;
	
	private JDOMAttributeField 	baseField ;
	private JDOMAttributeField 	providerField ;
	private JDOMAttributeField  loginField;
	private JFormPanel form ;
	
	private JDOMElementTablePanel paramsPane ;
	
	//
	// AbstractEditor
	//
	@Override
	final public void initParameters(Element para)
	{
		Element ldap = JDOMUtil.getElement(para, ConstLDAP.LDAP) ;
		Attribute base = JDOMUtil.getAttribute(ldap, ConstLDAP.BASE_DN) ;
		Attribute provider = JDOMUtil.getAttribute(ldap, ConstLDAP.SERVER_URL) ;
		Attribute login = JDOMUtil.getAttribute(ldap, ConstLDAP.LDAP_LOGIN) ;
		
		baseField = new JDOMAttributeField(base) ;
		providerField = new JDOMAttributeField(provider);
		loginField = new JDOMAttributeField(login);
		
		paramsPane = new JDOMElementTablePanel(para, tableBinding) ;
				
		form = new JFormPanel() ;
		form.addField(providerField, "LDAP server URL");
		form.addField(baseField, "Base DN") ;
		form.addField(loginField, "LDAP user Attribute") ;
		form.addField(paramsPane, "Parameters") ;
				
		setDialogTitle("LDAP authentication informations") ;
		
		setLayout(new BorderLayout()) ;
		setBorder(BorderFactory.createEmptyBorder(5,5,5,5)) ;
		add(form, BorderLayout.NORTH) ;
	}
}