/*
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.basicrpc.server.imp ;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;

import org.azuki.client.basicrpc.codec.ObjectDecoder;
import org.azuki.common.console.http.HttpRequest;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public class Http
{
	final static public Object readObject(HttpServletRequest req)
	throws IOException
	{
		byte[] content = HttpRequest.getContent(req) ;
		return readObject(content) ;
	}
	
	final static public Object readObject(byte[] content)
	throws IOException
	{
		if(content==null) return null ;

		try
		{
			String str = new String(content) ;
			
			return ObjectDecoder.decode(str) ;
		}
		catch(Exception e)
		{
			e.printStackTrace() ;
			throw new IOException(e.getMessage()) ;
		}
	}		
}