/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.chrono.server.imp;

final public class ChronoLine
{
	private int  calls = 0 ;
	final public int getCalls() { return calls ; }

	private long  tmin = Integer.MAX_VALUE ;
	final public long getMin() { return tmin ; }
	
	private long  tmax = 0 ;
	final public long getMax() { return tmax ; }
	
	private long total = 0 ;
	final public long getTotal(){ return total ; }

	private long lastCall = 0 ;
	final public long getLastCall() { return lastCall ; }
	 
	public long getAverage()		{ return total/calls ; }
	
	final public void add(long sta, long end)
	{
		calls++ ;
		lastCall = end ;
		
		long delta = end-sta ;
		
		total += delta ;
		
		if(tmin>delta) tmin = delta ;
		if(tmax<delta) tmax = delta ;
	}
}
