/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.command ;

import org.azuki.bean.command.server.imp.PCommand;
import org.azuki.bean.command.server.imp.queue.CmdQF;
import org.azuki.framework.command.*;
import org.azuki.framework.command.ICommand.Priority;
import org.azuki.framework.object.*;

/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */
final public class CommandBean implements IObjectFactory<Command.Impl>, Command.Impl
{
	final public String getObjectName()
	{
		return Locator.OBJECT_COMMAND ;
	}
	
	final public Command.Impl createObject(Object... args)
	{
		return this ;
	}
	
	
// Command.Impl
/////////////////////////////////////////////////////
	
	final public IQueue getQueue(String qname)
	{
		return CmdQF.instance().get(qname) ;
	}
	
	final public IQueue mainQueue()
	{
		return CmdQF.main() ;
	}
	
	
	@SuppressWarnings("unchecked")
	final public Object invoke(ICommand icmd)
	throws Exception
	{
		return PCommand.invoke(icmd, CmdQF.main(), Priority.NORMAL) ;
	}

	@SuppressWarnings("unchecked")
	final public Object invokeQueued(ICommand icmd, IQueue queue, Priority pty)
	throws Exception
	{
		return PCommand.invoke(icmd, queue, pty) ;
	}

	@SuppressWarnings("unchecked")
	final public void send(ICommand icmd)
	{
		PCommand.send(icmd, CmdQF.main(), Priority.NORMAL, null) ;
	}

	@SuppressWarnings("unchecked")
	final public void sendQueued(ICommand icmd, IQueue queue, Priority pty)
	{
		PCommand.send(icmd, queue, pty, null) ;
	}

	@SuppressWarnings("unchecked")
	final public void sendCallback(ICommand icmd, ICallback cback)
	{
		PCommand.send(icmd, CmdQF.main(), Priority.NORMAL, cback) ;
	}

	@SuppressWarnings("unchecked")
	final public void sendQueuedCallback(ICommand icmd, IQueue queue, Priority pty, ICallback cback)
	{
		PCommand.send(icmd, queue, pty, cback) ;
	}		
}