/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.command.server.imp;

import org.azuki.framework.command.ICommand;
import org.azuki.framework.context.*;

// This command decorator is used for
// the propagation of the launcher context 
// information (used new execution context only)

final public class CmdCtx<T> implements ICommand<T>
{
//	final public String getName() { return icmd.getName(); }

    final private ICommand<T> icmd ;
    final private IContext cx ;

    public CmdCtx(ICommand<T> icmd, IContext cx)
    {
    	this.icmd = icmd ;
    	this.cx   = cx ;
    }
    
	final public T process()
	throws Exception
	{
	    // Inherit context
		ThreadContext.set(cx) ;	
		return icmd.process() ;
	}
}