/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.command.server.imp.queue ;

import org.azuki.framework.command.ICommand;
import org.azuki.framework.context.*;


// Process Queue Reader

/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */
final public class QRd implements ICommand
{
    final private CmdQ cmdq ;

    public QRd(CmdQ cmdq)
    {
        this.cmdq = cmdq ;
    }

	final public String getName() { return cmdq.getName(); }	
    final public Object process()
    {
        while(true) // Tant que y'en a
        {
        	ICommand<?> cmd = cmdq.read(this);

            if(cmd == null) return null; // fin

            try
            {
                cmd.process() ; // CmdCBack put the trace and context
            }
            catch(Throwable t)
            {
                // Normally CmdCBack already trap exception
            	Log.severe(t.getMessage()) ;//Log.error(this, t);
            }
            finally
            {
            	// Important : Thread context reset after each command processing
				ThreadContext.reset() ; 
            }

            cmd = null ; // free, because queue handle a pool of Job
        }
    }
}