/*
 *   Created the 1 August 2007
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.compiler.server.imp ;

import java.net.URI;

import javax.tools.SimpleJavaFileObject;

/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */
final public class JavaObjectFromString extends SimpleJavaFileObject
{
	private String contents = null;

	public JavaObjectFromString(String srcname, String contents)
	throws Exception
	{
		super(new URI(srcname), Kind.SOURCE);
    	this.contents = contents;
    }
	
	@Override
	final public CharSequence getCharContent(boolean ignoreEncodingErrors)
	{
    	return contents;
    }
}