/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.context ;

import org.azuki.bean.context.server.imp.*;
import org.azuki.framework.context.*;
import org.azuki.framework.object.*;


/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */
final public class ContextBean implements IObjectFactory<ThreadContext.Impl>, ThreadContext.Impl
{
	final public String getObjectName()
	{
		return Locator.OBJECT_CONTEXT ;
	}
	
	final public ThreadContext.Impl createObject(Object... args)
	{
		return this ;
	}
	
	
// ThreadContext.Impl
/////////////////////////////////////////////////////
	final public IContext getContext()
	{
		return TCxMngr.get() ;
	}

	final public void setContext(IContext ictx)
	{
		TCxMngr.set((Cx)ictx) ;
	}
	
	final public void startThread(Thread thread)
	{
		TCxMngr.startThread(thread) ;
	}

	final public void setStatus(boolean state, String info)
	{
		TCxMngr.setStatus(state, info) ;
	}	

	final public void reset()
	{
		TCxMngr.reset() ;
	}		
}