/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.context.server.imp;

import java.util.Hashtable;


// Thread's Context Manager provides
// static access to Thread context
/////////////////////////////////////

final public class TCxMngr
{
	public enum THREAD_ORIGIN { AZUKI, EXTERN } 
		
	// Thread Context Map
	final static private Hashtable<Integer, TCx> TCS = new Hashtable<Integer, TCx>(100);

    // Current Thread Context 
    final static public TCx tcx()
    {
    	Integer tid = new Integer(Thread.currentThread().hashCode()) ;
    	TCx tc = TCS.get(tid) ;
    	if(tc!=null) return tc ;
    	
    	tc = new TCx(THREAD_ORIGIN.EXTERN, tid); // Pas Azuki, context est provisoire.
    	TCS.put(tid, tc);  		
    	return tc;
    }
    
    final static public void remove(Integer tid)
    {
    	TCS.remove(tid) ;
    }

	final static public Cx get()
	{
		return tcx().get() ;	
	}

	final static public void set(Cx cx)
	{
		tcx().set(cx) ;
	}
	
	// Starts new thread
	//////////////////////
	final static public void startThread(Thread thread)
	{
		// Mettre a jour tout de suite 
		// car ce qui caracterise un thread AZUKI.
    	Integer tid = new Integer(thread.hashCode()) ;	    	
    	TCS.put(tid, new TCx(THREAD_ORIGIN.AZUKI, tid)) ;
    	
    	// Start only after sinon creation par le thread lui-même d'un context !!!
		thread.start();		
	}
	
	
	// Thread Infos
	//////////////////////
	final static public int getCurrentThreadNumber()
	{
		return tcx().number;
	}

	final static public void setStatus(boolean run, String nfo)
    {
		TCx tcx = tcx() ;
    	tcx.run = run;
    	tcx.nfo = (nfo==null?TCx.IDLE:nfo) ;
    }

	final static public void reset()
	{
		tcx().reset() ;
	}
}
