/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.documentation.server.imp ;

import javax.servlet.http.HttpServletRequest;

import org.azuki.bean.documentation.DocumentationBean;
import org.azuki.common.console.http.HttpRequest;
import org.azuki.common.framework.BeanDefinition;
import org.azuki.common.util.StringUtil;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public class DocumentationUtil
{
	final static public String rsrcCtx = "!" ;
	
	final static public String mkRsrcURL(DocumentationBean da, HttpServletRequest req, String res)
	{
		StringBuilder bdr = new StringBuilder() ;
		bdr.append(documentationURI(da, req)) ;
		bdr.append('/') ;
		bdr.append(rsrcCtx) ;
		bdr.append('/').append(res) ;
		
		return bdr.toString() ;
	}
	
	final static public String mkBeanURL(DocumentationBean da, HttpServletRequest req, BeanDefinition bdef)
	{	
		StringBuilder bdr = new StringBuilder() ;
		bdr.append(documentationURI(da, req)) ;
		bdr.append('/') ;
		bdr.append(bdef.getName()) ;
//		bdr.append('/') ;
		
		return bdr.toString() ;
	}
	
	// /.../portal
	final static public String documentationURI(DocumentationBean da, HttpServletRequest req)
	{
		String puri = da.getURI() ;
		String ruri = HttpRequest.decodeURI(req) ;
		
		int idx = ruri.indexOf(puri) ;
		if(idx==-1) return null ; // impossible !
		
		String uri = puri.substring(0, idx+puri.length()) ;
		return StringUtil.slashStart(uri) ;
	}
	
	// .../documentation/something/... --> /something/...
	final static public String relativeURI(DocumentationBean da, HttpServletRequest req)
	{
		String puri = da.getURI() ;
		String ruri = HttpRequest.decodeURI(req) ;
		
		int idx = ruri.indexOf(puri) ;
		if(idx==-1) return null ; // pas possible !
		
		String uri = ruri.substring(idx+puri.length()) ;
		return StringUtil.slashStart(uri) ;
	}
}