/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.event.server.console;

import java.util.*;

import javax.servlet.http.*;

import org.azuki.bean.event.server.imp.*;
import org.azuki.common.console.*;
import org.azuki.common.console.html.Table;
import org.azuki.common.console.http.HttpResponse;
import org.azuki.common.util.ListUtil;

public class EventServiceConsole
{
	final static public String[] tableHeaders = {"Topic", "Listener", "Queued"} ;
	
	final static public void service(EventServiceImp event,HttpServlet servlet,HttpServletRequest req, HttpServletResponse res)
	throws Exception
	{
		Map<String, List<IListener>> map = event.getTopicListeners() ;
		
		List<List> data = new ArrayList<List>() ;
		
		for(String topic : map.keySet())
		{
			List<IListener> listener = map.get(topic);
			for (IListener il : listener)
				data.add(ListUtil.toList(topic, il.toString(), String.valueOf(il.isQueued()))) ;
		}
		
		Table table = HtmlFactory.sortedTable(req, data, tableHeaders) ; 
		
		HttpResponse.print(res, table) ;
	}
}
