/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin (yoann.perrin@gmail.com)
 */

package org.azuki.bean.exec.server.imp ;

import java.util.*;

public class ExecUtil
{
	final static public char quoteChar = '"' ;
	
	final static public String toString(String[] cmdarr)
	{
		return toString(cmdarr, quoteChar) ;
	}
	
	final static public String toString(String[] cmdarr, char quoteChar)
	{
		if(cmdarr==null) return null ;
		
		StringBuilder bdr = new StringBuilder() ;
		
		boolean first = true ;
		for(String str : cmdarr)
		{
			if(first)	first = false ;
			else		bdr.append(' ') ;
			
			boolean spc = str!=null && str.indexOf(' ')!=-1 ;
			
			if(spc) bdr.append(quoteChar) ;
			bdr.append(str) ;
			if(spc) bdr.append(quoteChar) ;
		}
		
		return bdr.toString() ;
	}
	
	final static public void merge(Map<String,String> map1, Map<String,String> map2)
	{
		if(map1==null || map2==null) return ;
		
		for(Map.Entry<String,String> ety2 : map2.entrySet())
		{
			String key = ety2.getKey() ;
			String val = ety2.getValue() ; 
			
			while(true)
			{
				int idx = val.indexOf("${") ;
				if(idx==-1) break ;
				
				int idx2 = val.indexOf("}", idx) ;
				if(idx2==-1) break ;
				
				String var = val.substring(idx+2, idx2) ;
					
				String varval = map1.get(var) ;
				if(varval==null) varval="" ;
				
				StringBuilder sb = new StringBuilder(val.substring(0, idx)) ;
				sb.append(varval) ;
				sb.append(val.substring(idx2+1)) ;
				val = sb.toString() ;
			}
			
			map1.put(key, val);
		}
	}
}