/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.exec.server.imp;

import java.io.OutputStream;
import java.util.Map;

import org.azuki.bean.exec.server.imp.mngr.ProcessManager;
import org.azuki.framework.command.ICommand;

public class Execution<T> implements ICommand<T>
{
	final private ProcessManager      pm   ;
	final private String              name ;
	private String[]            cmds ;
	final private Map<String, String> env  ; // inherited env
	final private Map<String, String> nenv ; // new env
	final private String              path ;
	final private OutputStream        outp ;
	
	public Execution(ProcessManager pm, String name, String[] cmds, Map<String, String> env, Map<String, String> nenv, String path, OutputStream outp)
	{
		this.pm   = pm   ;
		this.name = name ;
		this.cmds = cmds ;
		this.env  = env  ;
		this.nenv = nenv ;
		this.path = path ;
		this.outp = outp ;
	}
	
	final public void setCmd(String cmd)
	{
		this.cmds = new String[]{cmd};
	}
	
	final public T process()
	throws Exception
	{
		PProcess.exec(pm, name, cmds, env, nenv, path, outp) ;
		return null ;
	}
	
	@Override
	public String toString()
	{
		if (cmds==null) return "null command";
		
		StringBuilder sb = new StringBuilder();
		for (int i = 0 ; i < cmds.length; i++)
		{
			sb.append(cmds[i]);
			if (i<cmds.length-1)
				sb.append("\n");
		}
		return sb.toString();
	}
}