/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.exec.server.imp.mngr ;

import java.util.* ;


final public class PRunning
{
    // Running processes.
    final private Hashtable<Integer, Object[]> runs = new Hashtable<Integer, Object[]>() ; 

    final public void add(Integer ID, String name, String[] cmd, Process proc, long star)
    {
        runs.put(ID, new Object[] {name, cmd, proc, new Long(star) }) ;
    }

    final public void remove(Integer ID)
    {
        runs.remove(ID) ;
    }

    final public void kill(Integer ID)
    {
    	Object[] run = runs.remove(ID) ;
        if(run == null) return ;
        ((Process)run[2]).destroy();
    }

    final public List<Object[]> getInfo()
    {
        ArrayList<Object[]> list = new ArrayList<Object[]>() ;

        Enumeration enu = runs.keys() ;

        while(enu.hasMoreElements())
        {
            Integer ID = (Integer)enu.nextElement();
            Object[] run = runs.get(ID) ;

            Object[] infos = new Object[5] ;
            infos[0] = ID ;   // ID
            infos[1] = run[3] ;   // Start
            infos[2] = "run.user" ; // TODO ?
            infos[3] = run[0] ; // Name
            infos[4] = run[1] ; // cmd

            list.add(infos);
        }

        return list ;
    }
}