/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.global.editor;

import java.awt.BorderLayout;
import java.util.*;

import javax.swing.*;

import org.azuki.bean.global.editor.imp.CheckBoxTableCellRenderer;
import org.azuki.bean.global.shared.ConstGlobal;
import org.azuki.common.editor.*;
import org.azuki.common.editor.jdom.*;
import org.azuki.common.editor.pointcut.AbstractPointcutEditor;
import org.azuki.common.util.ListUtil;
import org.jdom.Element;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
final public class GlobalPointcutEditor extends AbstractPointcutEditor
{
	final static private JDOMElementTableBinding tableBinding
	= JDOMElementTableBinding.create(	TagCommon.ROW,
										ListUtil.asList(AttrCommon.NAME, AttrCommon.VALU, ConstGlobal.EXEC),
										ListUtil.asList(ConstCommon.NAME, ConstCommon.VALU, "Inherit Exec"),
										Collections.singletonMap(ConstGlobal.EXEC, Boolean.TRUE.toString())) ;
	
	private JCheckBox execCheck ;
	private JDOMElementTablePanel tablePanel ;
	
	/*
	 * AbstractEditor
	 */
	@Override
	final public void initParameters(Element para)
	{
		execCheck = new JCheckBox() ;
		execCheck.setHorizontalAlignment(SwingConstants.CENTER) ;
		
		tablePanel = new JDOMElementTablePanel(para, tableBinding) ;
		tablePanel.getTable().getColumnModel().getColumn(2).setCellEditor(new DefaultCellEditor(execCheck)) ;
		tablePanel.getTable().getColumnModel().getColumn(2).setCellRenderer(new CheckBoxTableCellRenderer()) ;
		
		setDialogTitle("Environment configuration") ;
		
		setLayout(new BorderLayout()) ;
		setBorder(BorderFactory.createEmptyBorder(5,5,5,5)) ;
		add(tablePanel, BorderLayout.CENTER) ;
	}
	
	@Override
	final public void initFields(List<Element> flds)
	{}

	@Override
	final public void initMethods(List<Element> mths)
	{}
}
