/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.global.server ;

import org.azuki.bean.global.server.imp.GlobalMap;
import org.azuki.framework.context.*;
import org.azuki.framework.context.IContext.IStub;
import org.azuki.framework.injection.*;

// Advice that implement a Controller to add in the Context all variables.

final public class GlobalAdvice implements IController
{
	final private GlobalMap map ;
	
	public GlobalAdvice(GlobalMap map)
	{
		this.map = map ;
	}

	public Object intercept(InvocationTarget it) 
	throws Exception
	{
		GlobalMap env = (GlobalMap)ThreadContext.lookup(IContext.OBJECT_GLOBAL) ;
		env.putAllVar(map) ;
				
		// proceed method & manage context
		IContext ictx = ThreadContext.get() ;
		
		IStub stub = ictx.bind(IContext.OBJECT_GLOBAL, env, new GlobalLifecycle()) ;
		
		try
		{ return it.proceed() ; }
		finally
		{ ictx.unbind(IContext.OBJECT_GLOBAL, stub) ; }
	}
}