/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Roert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.global.server ;

import java.util.Map;

import org.azuki.bean.global.server.imp.GlobalMap;
import org.azuki.framework.context.IContext;
import org.azuki.framework.object.*;

public class GlobalFactory implements IObjectFactory<GlobalMap>, ILifecycleFactory<GlobalMap>
{
	private GlobalMap envp = null ;
	final protected GlobalMap getenv()
	{
		if(envp!=null) return envp ;
		
		envp = new GlobalMap() ;
			
		Map<String, String> sysEnv = System.getenv() ;
		for(Map.Entry<String, String> ety : sysEnv.entrySet())
			envp.putVar(ety.getKey(), ety.getValue(), true) ;
		
		return envp ;
	}

	final public String getObjectName()
	{
		return IContext.OBJECT_GLOBAL ;
	}
	
	final public GlobalMap createObject(Object... args)
	{
		// duplicate map for Context.
		return getenv().clone() ;
	}
	
	final public ILifecycle<GlobalMap> getLifeCycle()
	{
		return new GlobalLifecycle();
	}
}