/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.global.server.console;

import java.util.*;

import javax.servlet.http.*;

import org.azuki.bean.global.server.imp.*;
import org.azuki.common.console.HtmlFactory;
import org.azuki.common.console.html.Table;
import org.azuki.common.console.http.HttpResponse;
import org.azuki.common.util.ListUtil;
import org.azuki.framework.context.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */
public final class GlobalConsole
{
	final static public String[] tableHeaders = {"Key", "Value", "Inherited"} ;
	
	final public static void service(HttpServlet srv, HttpServletRequest req, HttpServletResponse res)
	throws Exception
	{		
		GlobalMap envp = (GlobalMap)ThreadContext.lookup(IContext.OBJECT_GLOBAL) ;
		
		List<List> data = new ArrayList<List>() ;
		
		for(Map.Entry<String,GlobalVar> ety : envp.varSet())
		{
			String key      = ety.getKey()   ;
			GlobalVar tuple = ety.getValue() ;
			
			data.add(ListUtil.toList(key, tuple.getValue(), new Boolean(tuple.isInherit()))) ; 
		}
		
		Table table = HtmlFactory.sortedTable(req, data, tableHeaders) ;
		
		HttpResponse.print(res, table) ;
	}
}
