/*
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.graniteds;

import javax.servlet.http.*;

import org.azuki.bean.graniteds.server.imp.PService;
import org.azuki.common.bean.rpc.AbstractRpcBean;
import org.azuki.framework.annotation.MethodInfo;
import org.azuki.framework.context.*;

/**
 * @author Robert Bakic (robert.bakic@gmail.com)
 */

public class GraniteDSBean extends AbstractRpcBean
{	
	@MethodInfo(desc="The contract implementation of the request dispatcher aspect (RequestDispatcher)")
	final public void service(HttpServlet srv, HttpServletRequest req, HttpServletResponse res)
	throws Exception
	{
		IContext cx = ThreadContext.get() ;

		/* TODO ?
		if(isSecured())
		{
			 
			try
			{
				HttpSession sess = req.getSession(false) ;
				if(sess==null) throw new Exception("No valid session.") ;
				
				Object user = sess.getAttribute(IContext.ATTR_USER) ;
				if(user==null) throw new Exception("No user defined.") ;

				cx.bind(IContext.ATTR_USER, user, new ProcessLifecycle()) ;
			}
			catch(Exception ex)
			{
				Log.info(ex.getMessage()) ;
				throw ex ;
			}
		}
		*/
		
		cx.bind(IContext.OBJECT_HTTPREQUEST, req, null) ; // If you need information from the original servlet request

		PService.p(this, srv, req, res) ;
	}
}
