/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic
 */

package org.azuki.bean.injection.server.imp;

import java.io.*;

import org.azuki.bean.injection.server.imp.MethodProxyImp.IMILogger;
import org.azuki.framework.context.Log;


public class MILogger implements IMILogger 
{
	static private PrintWriter out ;
	
	static
	{
	    try
	    {
			// Not append, Autoflush
			out = new PrintWriter(new FileOutputStream("call.log", false), true);
	    }
	    catch(Exception e)
	    {
	        e.printStackTrace() ;
	    }
	}		
	
	static private int space = 0 ;
	final public void start(int pid, int cxid, Integer bid, String meth)
	{
		line(">>", pid, cxid, bid, meth) ;
		space++ ;
	}

	final public void end(int pid, int cxid, Integer bid, String meth)
	{
		//line("<<", tcid, bid, meth) ;
		space--;
	}

	final public void exception(int pid, int cxid, Integer bid, String meth, Exception e)
	{
		//line("EXC", tcid, bid, meth) ;		
		out.println(Log.getStack(e)) ;
		space--;
	}
	
	static private int oldcxid = -1 ;
	final static private void line(String type, int pid, int cxid, Integer bid, String meth)
	{
		if(oldcxid!=cxid)
		{
			out.println("\n PID("+pid+") CTX("+cxid+")") ;
			oldcxid=cxid ;
			space=0 ; // pour eviter les ecarts du au exception 
		}
		
		StringBuilder sb = new StringBuilder();
		for(int i=0; i<space; i++) sb.append("   ");
		sb.append("[").append(bid).append("]").append(meth) ;
		out.println(sb.toString());		
	}		
}