package org.azuki.bean.itext ;

import java.io.ByteArrayOutputStream;
import java.util.*;

import org.azuki.framework.annotation.*;
import org.azuki.framework.context.Log;

import com.lowagie.text.Document;
import com.lowagie.text.pdf.*;

public class ITextMergeBean
{
	@SuppressWarnings("unchecked")
	@Export
	@MethodInfo(desc="Merge multiple PDF files", retu="The merge PDF file bytes")
	final public byte[] merge(@ArgInfo(name="arrs", desc="The PDF files bytes")byte[]... arrs)
	throws Exception
	{
		Log.info("Merging "+arrs.length+" PDF files...") ;
		
		ByteArrayOutputStream baos = new ByteArrayOutputStream() ;
			
		Document docu = null ;
		PdfCopy  copy = null ;
		
		List mark = new ArrayList() ;
		
		int shft = 0 ;
		
		for(byte[] byts : arrs)
		{
			PdfReader pdfreader = new PdfReader(byts) ;
			pdfreader.consolidateNamedDestinations() ;
			
			if(docu==null) // lazy
			{
				docu = new Document(pdfreader.getPageSizeWithRotation(1)) ;
				copy = new PdfCopy(docu, baos) ;
				docu.open() ;
			}
			
			List temp = SimpleBookmark.getBookmark(pdfreader) ;
			if(temp!=null)
			{
				if(shft>0) SimpleBookmark.shiftPageNumbers(temp, shft, null) ;
				mark.addAll(temp) ;
			}
			
			int nbpg = pdfreader.getNumberOfPages() ;
			shft += nbpg ;
			
			for(int i=0 ; i<nbpg ; i++)
			{
				PdfImportedPage pdfimportedpage = copy.getImportedPage(pdfreader, i+1) ;
				copy.addPage(pdfimportedpage) ;
			}

			copy.freeReader(pdfreader) ;
		}

		if(!mark.isEmpty()) copy.setOutlines(mark) ;
		
		docu.close() ;
		
		return baos.toByteArray() ;
	}
}