/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin (yoann.perrin@gmail.com)
 */

package org.azuki.bean.jmx.editor ;

import java.awt.BorderLayout;
import java.util.List;

import javax.swing.BorderFactory;

import org.azuki.bean.jmx.shared.ConstJMX;
import org.azuki.common.editor.jdom.JDOMAttributeField;
import org.azuki.common.editor.pointcut.AbstractPointcutEditor;
import org.azuki.common.util.JDOMUtil;
import org.azuki.common.widget.JFormPanel;
import org.jdom.Element;

@SuppressWarnings("serial")
public class JMXListenerEditor extends AbstractPointcutEditor
{
	JDOMAttributeField nameField ;
	JDOMAttributeField lablField ;
	
	JFormPanel form ;
	
	/*
	 * AbstractPointcutEditor
	 */
	@Override
	final public void initParameters(Element para)
	{
		Element jmxl = JDOMUtil.getElement(para, ConstJMX.LISTEN) ;
		
		nameField = new JDOMAttributeField(JDOMUtil.getAttribute(jmxl, ConstJMX.LISTEN_NAME, "")) ;
		lablField = new JDOMAttributeField(JDOMUtil.getAttribute(jmxl, ConstJMX.LISTEN_LABEL, "")) ;
		
		form = new JFormPanel() ;
		form.addField(nameField, "Bean name") ;
		form.addField(lablField, "Bean label") ;
		
		setDialogTitle("JMX listener configuration") ;
		
		setLayout(new BorderLayout(5,5)) ;
		setBorder(BorderFactory.createEmptyBorder(5,5,5,5)) ;
		add(form, BorderLayout.NORTH) ;
	}

	@Override
	final public void initFields(List<Element> flds)
	{}

	@Override
	final public void initMethods(List<Element> mths)
	{}
}