/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin (yoann.perrin@gmail.com)
 */

package org.azuki.bean.jmx.server.imp ;

import java.lang.reflect.Field;

final public class JMXReflect
{
	final static public Field getField(Object inst, String fieldName)
	throws NoSuchFieldException
	{
		// getDeclaredField(...) : return all declared field
		// getField(..)          : return only public field
		return inst.getClass().getField(fieldName) ;
	}
	
	final static public void setFieldValue(Object inst, String fieldName, Object newValue)
	throws IllegalAccessException, NoSuchFieldException 
	{
		Field field = getField(inst, fieldName) ;
		setFieldValue(inst, field, newValue) ;
	}
	
	final static public void setFieldValue(Object inst, Field field, Object newValue)
	throws IllegalAccessException
	{
		field.set(inst, newValue) ;
	}
	
	final static public Object getFieldValue(Object inst, String fieldName)
	throws IllegalAccessException, NoSuchFieldException
	{
		Field field = getField(inst, fieldName) ;
		return getFieldValue(inst, field) ;
	}
	
	final static public Object getFieldValue(Object inst, Field field)
	throws IllegalAccessException
	{
		return field.get(inst) ;
	}
}