/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin (yoann.perrin@gmail.com)
 */
package org.azuki.bean.jmx.server.imp ;

import java.lang.reflect.*;

import javax.management.*;

public class JMXUtil
{
	final static public boolean contains(Method[] meths, String methodName)
	{
		for(Method meth : meths)
			if(meth.getName().equals(methodName)) return true ;
		
		return false ;
	}
	
	final static public String getImpactString(int impact)
	{
		switch(impact)
		{
			case MBeanOperationInfo.ACTION 		: return "ACTION" ;
			case MBeanOperationInfo.ACTION_INFO : return "ACTION_INFO" ;
			case MBeanOperationInfo.INFO 		: return "INFO" ;
			default 							: return "UNKNOWN" ;
		}
	}
	
	final static public String toSignature(MBeanOperationInfo mboi)
	{
		StringBuilder bdr = new StringBuilder() ;
		bdr.append(mboi.getName()).append('(') ;
		
		boolean first = true ;
		for(MBeanParameterInfo mbpi : mboi.getSignature())
		{
			if(first) 	first = false ;
			else		bdr.append(", ") ;
			bdr.append(mbpi.getType()).append(' ').append(mbpi.getName()) ;
		}
		
		bdr.append(')') ;
		bdr.append(':').append(mboi.getReturnType()) ;
		
		return bdr.toString() ;
	}
}