/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin (yoann.perrin@gmail.com)
 */

package org.azuki.bean.jmx.server.imp ;

import java.util.Hashtable;

import javax.management.*;

public class ObjectNameFactory
{
	final static public String keyBean  = "bean" ;
	final static public String keyLabel = "label" ;
//	final static public String keyBid   = "id" ;
	
	//TODO: inclure le type(bean,aspect) ??
	
	final static public ObjectName create(String domain, String name, String labl, Integer bid)
	throws MalformedObjectNameException
	{
		if(labl==null || labl.trim().isEmpty())
			labl = "(no label)" ;
		
		Hashtable<String,String> map = new Hashtable<String,String>() ;
		map.put(keyBean , name) ;
		map.put(keyLabel, labl) ;
//		map.put(keyBid  , bid.toString()) ;
		
		return new ObjectName(domain, map) ;
	}
}