/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin (yoann.perrin@gmail.com)
 */
package org.azuki.bean.jvm ;

import java.util.Map;

import javax.servlet.http.*;

import org.azuki.bean.jvm.server.console.JVMConsole;
import org.azuki.bean.jvm.shared.ConstJVM;
import org.azuki.common.editor.EditorUtil;
import org.azuki.framework.annotation.MethodInfo;
import org.jdom.Element;

public class JVMBean
{
	@MethodInfo(desc="Initializer contract implementation. Called at the framework initialization. Must not be called by others means")
	final public void postCreate(Element lmen)
	throws Exception
	{
		Map<String,String> map = EditorUtil.childrenToMap(lmen, ConstJVM.PROPERTY, ConstJVM.PROPERTY_NAME, ConstJVM.PROPERTY_VALUE) ;
		
		for(Map.Entry<String,String> ety : map.entrySet())
			System.setProperty(ety.getKey(), ety.getValue()) ;
	}
	
	final public void console(HttpServlet svt, HttpServletRequest req, HttpServletResponse res)
	throws Exception
	{
		JVMConsole.service(req, res) ;
	}
}