/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.logger.server.imp;

import java.io.*;
import java.util.logging.*;

public class OutputHandler extends Handler
{	
	final private PrintWriter pw ;
	
	public OutputHandler(OutputStream os)
	{
		this(new PrintWriter(os)) ;
	}
	
	public OutputHandler(PrintWriter pw)
	{
		this.pw = pw ;
	}
	
	@Override
	final public void publish(LogRecord rec)
	{
		if(!isLoggable(rec)) return ;
		
		pw.println(rec.getMessage()) ;
		pw.flush() ;
	}

	@Override
	final public void flush()
	{
		pw.flush() ;
	}

	@Override
	final public void close()
	throws SecurityException
	{
		//The user who created the stream must close it by its own !!!
		//pw.close() ;
	}
}