/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.logger.server.shell ;

import org.azuki.bean.logger.server.imp.AbstractHandlerBean;
import org.azuki.bean.logger.shared.ConstFileHandler;
import org.azuki.common.util.*;
import org.azuki.framework.aop.IPointcut;
import org.azuki.framework.bean.*;

/**
 * @author Mathieu Jucker (mathieu.jucker@azuki-framework.org)
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public class HandlerShell
{
	/**
	 * Available commands : list
	 */
	final static public String listPointcuts(AbstractHandlerBean aspt)
	throws Exception
	{
		StringBuilder bdr = new StringBuilder() ;
		
		IMetadata meta = aspt.getMetadata() ;
		
		bdr.append("Handler [").append(Util.oneString(meta.getName(), meta.getLabel())).append("]") ;
		bdr.append('\n') ;
		bdr.append(aspt.shellInfo()) ;
		
		// headers
		StringBuilder tmp = new StringBuilder() ;
		tmp.append(ShellUtil.rpad("Bean", ConstFileHandler.SZ_BEAN)) ;
		tmp.append("\n") ;
		tmp.append(ShellUtil.rpad("", tmp.length(), '-')) ;
		tmp.append("\n") ;
		
		bdr.append(tmp) ;
		
		// lines
		for(IPointcut pc : Bean.getPointcuts(aspt.getMetadata().getID()))
		{
			IMetadata tmeta = pc.getTargetMetadata() ;
			
			bdr.append(ShellUtil.rpad(Util.oneString(tmeta.getName(), tmeta.getLabel()), ConstFileHandler.SZ_BEAN)) ;
			bdr.append("\n") ;
		}
		
		return bdr.toString() ;
	}
}