/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.logger.shared;

import java.util.logging.Level;

import org.azuki.common.consts.Const;

public interface ConstFileHandler
{
	// Default values
	final static public String defaultDirectory 	= "./logs" ;
	final static public String defaultFile 			= "log.txt" ;
	final static public String defaultDaily 		= Const.NO ;
	final static public String defaultRotate 		= Const.YES ;
	final static public String defaultLevel 		= Level.INFO.getName() ;
	final static public Integer defaultMaxKBytes 	= new Integer(250) ; // in Kb
	
	// DOM constants
	final static public String LOG_DIR  = "dir";
	final static public String LOG_FILE = "file";
	final static public String LOG_DAIL = "daily";
	final static public String LOG_ROTA = "rotate";
	final static public String LOG_MAXB = "maxb";
	
	// Max. strings size
	final static public int SZ_BEAN = 35;
	final static public int SZ_STATUS = 15;
	final static public int SZ_ENABLED = 15;
}
