/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.logger.shared;

import java.text.SimpleDateFormat;
import java.util.Date;

public class UtilFileHandler
{
	final static private SimpleDateFormat sdf = new SimpleDateFormat("yyyy.MM.dd", java.util.Locale.US) ;
	
	final static public String mkDay()
	{
		return sdf.format(new Date(System.currentTimeMillis())) ;
	}
	
	final static public String mkFile(String dire, String file, boolean date)
	{
		if(dire==null) dire="" ;
		
		StringBuilder sb = new StringBuilder(trimSlash(dire)) ;
		if(date) sb.append('/').append(mkDay()) ;
		sb.append('/').append(file) ;
		
		return sb.toString() ;
	}
	
	final static private String trimSlash(String s)
	{
		if(s==null || s.trim().isEmpty()) return s ;
		
		s = s.trim() ;

		char c = s.charAt(0) ;
		if(c=='/' || c=='\\') s = s.substring(1) ;
		
		c = s.charAt(s.length()-1) ;
		if(c=='/' || c=='\\') s = s.substring(0, s.length()-1) ;
		
		return s ;
	}
}
