/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.mail.server.imp;

import java.io.* ;

/*
US-ASCII     Seven-bit ASCII, a.k.a. ISO646-US, a.k.a. the Basic Latin block of the Unicode character set
ISO-8859-1   ISO Latin Alphabet No. 1, a.k.a. ISO-LATIN-1
UTF-8        Eight-bit UCS Transformation Format
UTF-16BE     Sixteen-bit UCS Transformation Format, big-endian byte order
UTF-16LE     Sixteen-bit UCS Transformation Format, little-endian byte order
UTF-16       Sixteen-bit UCS Transformation Format, byte order identified by an optional byte-order mark
*/

final public class ByteDS implements javax.activation.DataSource
{
	private byte[] data;	// data
	private String type;	// Content-type

	public ByteDS(byte[] data, String type)
	{
		this.data = data ;
		this.type = type ;
	}

	/**
	 * Return an InputStream for the data.
	 * Note - a new stream must be returned each time.
	 */
	final public InputStream getInputStream()
	throws IOException
	{
		if (data == null) throw new IOException("no data");
		return new ByteArrayInputStream(data);
	}

	final public OutputStream getOutputStream()
	throws IOException
	{
		throw new IOException("cannot do this");
	}

	final public String getContentType()
	{
		return type;
	}

	final public String getName()
	{
		return "dummy";
	}
}

