/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.ooo.editor ;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;

import org.azuki.bean.ooo.shared.ConstOOO;
import org.azuki.common.editor.IEditorContext;
import org.azuki.common.editor.basic.AbstractEditor;
import org.azuki.common.editor.jdom.*;
import org.azuki.common.util.JDOMUtil;
import org.azuki.common.widget.JFormPanel;
import org.jdom.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */
@SuppressWarnings("serial")
public class OOConverterEditor extends AbstractEditor<IEditorContext>
{
	JDOMAttributeField hostField ;
	JDOMNumberField portField ;
	
	JFormPanel form ;
	
	//
	// AbstractEditor
	//
	@Override
	final public void initParameters(Element para)
	{
		Element conv = JDOMUtil.getElement(para, ConstOOO.CONV) ;
		
		Attribute host = JDOMUtil.getAttribute(conv, ConstOOO.CONV_HOST) ;
		Attribute port = JDOMUtil.getAttribute(conv, ConstOOO.CONV_PORT) ;
		
		hostField = new JDOMAttributeField(host) ;
		
		portField = new JDOMNumberField(1, 65536, 10) ;
		portField.setAttribute(port) ;
		
		form = new JFormPanel() ;
		form.addField(hostField, "Host name") ;
		form.addField(portField, "Port") ;
		
		setBorder(BorderFactory.createEmptyBorder(5,5,5,5)) ;
		setLayout(new BorderLayout()) ;
		add(form, BorderLayout.NORTH) ;
	}
}