/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 *   @author Yoann Perrin (yoann.perrin@gmail.com)
 */

package org.azuki.bean.queuing.editor;

import java.awt.BorderLayout;
import java.util.List;

import org.azuki.bean.queuing.shared.ConstQueuing;
import org.azuki.common.consts.Const;
import org.azuki.common.editor.jdom.*;
import org.azuki.common.editor.pointcut.AbstractPointcutEditor;
import org.azuki.common.util.JDOMUtil;
import org.azuki.common.widget.JFormPanel;
import org.jdom.*;

@SuppressWarnings("serial")
public class QueuingEditor extends AbstractPointcutEditor
{
	private JDOMNumberUnlimitedField thrdField ;
	private JDOMNumberUnlimitedField sizeField ;
	private JDOMCheckBox shifField ;
	
	private JFormPanel form ;

	/*
	 * AbstractPointcutEditor
	 */
	@Override
	final public void initParameters(Element para)
	{
		thrdField = new JDOMNumberUnlimitedField(1, 999, 1, -1) ;
		sizeField = new JDOMNumberUnlimitedField(1, 999999, 1, -1) ;
		shifField = new JDOMCheckBox(Const.YES, Const.NO, false) ;
		
		Element queuLmen = JDOMUtil.getElement(para, ConstQueuing.QUEUE) ;
		
		Attribute thrdAttr = JDOMUtil.getAttribute(queuLmen, ConstQueuing.THREAD) ;
		Attribute sizeAttr = JDOMUtil.getAttribute(queuLmen, ConstQueuing.SIZE) ;
		Attribute shifAttr = JDOMUtil.getAttribute(queuLmen, ConstQueuing.SHIFT) ;
		
		thrdField.setAttribute(thrdAttr) ;
		sizeField.setAttribute(sizeAttr) ;
		shifField.setAttribute(shifAttr) ;
		
		form = new JFormPanel() ;
		form.addField(thrdField, "Max. thread") ;
		form.addField(sizeField, "Queue size") ;
		form.addField(shifField, "Shift") ;
		
		setDialogTitle("Queuing") ;
		
		setLayout(new BorderLayout()) ;
		add(form, BorderLayout.NORTH) ;
	}

	@Override
	final public void initFields(List<Element> flds)
	{}

	@Override
	final public void initMethods(List<Element> mths)
	{}
}
