/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.scheduler.editor.imp;

import java.util.*;

import org.azuki.bean.scheduler.shared.ConstSched;
import org.jdom.Element;

public class SchedConverter
{
	final public static Map paraTypeToMap(Element para)
	{
		HashMap<String,String> hmp = new HashMap<String,String>();
		
		if (para.getChildren()==null) return null;
		Element type = para.getChild(ConstSched.TYPE);
		if (type==null) return null;
		hmp.put(ConstSched.VALUE, type.getAttributeValue(ConstSched.VALUE));
		hmp.put(ConstSched.HOUR,type.getAttributeValue(ConstSched.HOUR));
		hmp.put(ConstSched.MINU,type.getAttributeValue(ConstSched.MINU));
		hmp.put(ConstSched.SECO,type.getAttributeValue(ConstSched.SECO));
		return hmp;
	}
	
	final public static Map paraWeekToMap(Element para)
	{
		return paraMonthWeekToMap(para, ConstSched.WEEK);
	}
	
	final public static Map paraMonthToMap(Element para)
	{
		return paraMonthWeekToMap(para,ConstSched.MONTH);
	}
	
	final private static Map paraMonthWeekToMap(Element para, String elmName)
	{
		HashMap<String,String> hmp = new HashMap<String,String>();
		
		if (para.getChildren()==null) return null;
		Element x = para.getChild(elmName);
		if (x==null) return null;
		hmp.put(ConstSched.ALL,x.getAttributeValue(ConstSched.ALL));
		hmp.put(ConstSched.DAYS,x.getAttributeValue(ConstSched.DAYS));
		return hmp;
	}
}
