/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

package org.azuki.bean.scheduler.server;

import org.azuki.framework.bean.IMetadata;
import org.azuki.framework.command.*;
import org.azuki.framework.injection.IMethodProxy;
import org.azuki.framework.object.Locator;

final public class SchedulerAdvice implements ICommand
{
	final private IMethodProxy mp ;
	final private IQueue queue ;
	
	private boolean step = false ;
	
	public SchedulerAdvice(IMetadata meta, String meth)
	throws Exception
	{
		queue = meta.getQueue() ;
		mp = (IMethodProxy)Locator.create(Locator.OBJECT_METHOD_PROXY, meta.getName(), meta.getLabel(), meth) ;
	}

	//
	// ICommand
	//
	final public Object process()
	throws Exception
	{
		// cette ICommand est directement placée dans la main Q,
		// il faut la mettre dans la Q du bean
		if(step) mp.call() ;
		else	 queue.put(this) ;
		
		step = true ;
		
		return null ;
	}
}