/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Mathieu Jucker
 */

package org.azuki.bean.scheduler.server.shell ;

import java.util.List;

import org.azuki.bean.scheduler.SchedulerBean;
import org.azuki.bean.scheduler.shared.ConstSched;
import org.azuki.common.console.renderer.HourRenderer;
import org.azuki.common.util.ShellUtil;

final public class SchedulerShell
{
	final static public String listJobs(SchedulerBean aspt)
	throws Exception
	{
		StringBuilder bdr = new StringBuilder() ;
		
		List<Object[]> jobs = aspt.list() ;
		
		if(jobs==null)
		{	bdr.append("no job are scheduled").append("\n") ;
			return bdr.toString() ; }

		// headers
		StringBuilder tmp = new StringBuilder() ;
		tmp.append(ShellUtil.rpad("Job ID", ConstSched.SZ_ID)) ;
		tmp.append(ShellUtil.rpad("Job Name", ConstSched.SZ_JOBNAME)) ;
		tmp.append(ShellUtil.rpad("When", ConstSched.SZ_WHEN)) ;
		tmp.append(ShellUtil.rpad("Period", ConstSched.SZ_PERIOD)) ;
		tmp.append(ShellUtil.rpad("Status", ConstSched.SZ_STATUS)) ;
		tmp.append("\n") ;
		tmp.append(ShellUtil.rpad("", tmp.length(), '-')) ;
		tmp.append("\n") ;
		
		bdr.append(tmp) ;
		
		// lines
		for(Object[] job : jobs)
		{
			Integer ID   = (Integer)job[0] ;
			String  name = (String) job[1] ;
			String  when = (String) job[2] ;
			Long    peri = (Long) job[3] ;
			String  stus = (String) job[4] ;
			
			// 	table datas
			bdr.append(ShellUtil.rpad(ID.toString(), ConstSched.SZ_ID)) ;
			bdr.append(ShellUtil.rpad(name, ConstSched.SZ_JOBNAME)) ;
			bdr.append(ShellUtil.rpad(when, ConstSched.SZ_WHEN)) ;
			bdr.append(ShellUtil.rpad(HourRenderer.get(peri), ConstSched.SZ_PERIOD)) ;
			bdr.append(ShellUtil.rpad(stus, ConstSched.SZ_STATUS)) ;
			bdr.append("\n") ;
		}
		
		return bdr.toString() ;
	}	
}