/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin (yoann.perrin@gmail.com)
 */

package org.azuki.bean.tomcat.server.imp ;

import java.util.*;

import org.azuki.bean.tomcat.shared.ConstTomcat;
import org.jdom.Element;

public class TomcatServlet
{
	final public String name ;
	final public String clas ;
	final public String mapg ;
	
	final public Integer load ;
	
	final public Map<String,String> para ;
	
	TomcatServlet(String name, String clas, String mapg, Integer load, Map<String,String> para)
	{
		this.name = name ;
		this.clas = clas ;
		this.mapg = mapg ;
		this.load = load ;		
		this.para = para ;
	}
	
	@SuppressWarnings("unchecked")
	final static public TomcatServlet create(Element lmen)
	throws Exception
	{
		String name = lmen.getAttributeValue(ConstTomcat.SERVLET_NAME) ;
		String clas = lmen.getAttributeValue(ConstTomcat.SERVLET_CLAS) ;
		String mapg = lmen.getAttributeValue(ConstTomcat.SERVLET_MAPG) ;
		
		Integer load = Integer.valueOf(lmen.getAttributeValue(ConstTomcat.SERVLET_LOAD)) ;
		
		Map<String,String> para = new HashMap<String,String>() ;
		
		List<Element> params = lmen.getChildren(ConstTomcat.SERVLET_PARA) ;
		for(Element param : params)
		{
			String pkey = param.getAttributeValue(ConstTomcat.SERVLET_PARA_NAME) ;
			String pval = param.getAttributeValue(ConstTomcat.SERVLET_PARA_VALU, "") ;
			para.put(pkey, pval) ;
		}
		
		return new TomcatServlet(name, clas, mapg, load, para) ;
	}
}