/**
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 *
 *   @author Yoann Perrin
 */

package org.azuki.bean.tomcat.shared ;

import java.util.logging.Level;

import org.azuki.bean.tomcat.server.imp.HttpConstants;
import org.azuki.common.consts.Attr;

public interface ConstTomcat
{
	final static public Integer MIN_PRIORITY = Integer.valueOf(Thread.MIN_PRIORITY) ;
	final static public Integer NORM_PRIORITY = Integer.valueOf(Thread.NORM_PRIORITY) ;
	final static public Integer MAX_PRIORITY = Integer.valueOf(Thread.MAX_PRIORITY) ;
	
	final static public String defaultBaseDir = "." ;
	final static public String defaultHttpRoot = "./web" ;
	final static public String defaultWelcomeFile = "index.html" ;
	final static public String defaultJvmRoute = "NODE1" ;
	final static public String defaultLoggingDirectory = "./logs" ;
	final static public String defaultLoggingLevel = Level.ALL.getName() ;
	
	final static public String defaultScheme = HttpConstants.SCHEME_HTTP ;
	final static public String defaultPort = "8081" ;
	final static public String defaultMaxThreads = "200" ;
	final static public String defaultMinSpareThreads = "4" ;
	final static public String defaultMaxSpareThreads = "50" ;
	final static public String defaultAcceptCount = "10" ;
	final static public String defaultThreadPriority = NORM_PRIORITY.toString() ;
	
	/**
	 * ENGINE
	 */
	final static public String ENGINE = "engine" ; // Tag
	final static public String ENGINE_BDIR = "baseDir" ;
	final static public String ENGINE_HROO = "httpRoot" ;
	final static public String ENGINE_WELC = "welcomeFile" ;
	final static public String ENGINE_JVMR = "jvmRoute" ;
	
		final static public String LOGGING = "logging" ; // Tag
		final static public String LOGGING_DIR  = "dir" ;
		final static public String LOGGING_LEVL = "level" ;
	
		final static public String SERVLET = "servlet" ; // Tag
		final static public String SERVLET_NAME = "name" ;
		final static public String SERVLET_CLAS = "class" ;
		final static public String SERVLET_MAPG = "mapping" ;
		final static public String SERVLET_LOAD = "loadOnStartup" ;
		final static public String SERVLET_ENAB = Attr.ENAB ;
			
			final static public String SERVLET_PARA = "parameter" ;	// Tag
			final static public String SERVLET_PARA_NAME = "name" ;
			final static public String SERVLET_PARA_VALU = "value" ;
			
		final static public String MIME = "mime-mapping" ; // Tag
		final static public String MIME_EXTE = "extension" ;
		final static public String MIME_TYPE = "mime-type" ;
	
	/**
	 * CONNECTOR
	 */
	final static public String CONNECTOR = "connector" ; // Tag
	final static public String CONNECTOR_SCHM = "scheme" ;
	final static public String CONNECTOR_PORT = "port" ;
	
		final static public String SECURITY = "security" ;	// Tag
		final static public String SECURITY_KFIL = "keystoreFile" ;
		final static public String SECURITY_KPAS = "keystorePass" ;
	
		final static public String POOL = "pool" ;
		final static public String POOL_MAXT = "maxThreads" ;
		final static public String POOL_MINS = "minSpareThreads" ;
		final static public String POOL_MAXS = "maxSpareThreads" ;
		final static public String POOL_ACCP = "acceptCount" ;
		final static public String POOL_PRIO = "threadPriority" ;
}