/*
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.xml ;

import javax.servlet.http.*;

import org.azuki.common.util.SQLXML;
import org.azuki.framework.annotation.*;
import org.azuki.framework.injection.IMethodProxy;
import org.azuki.framework.injection.IMethodProxy.*;
import org.jdom.Document;


/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

final public class SQLtoXMLBean
{
	final static private String outputName = "xmldoc";
	
	// EventPublisher injection
	@DependencyInjectionInfo(desc="Publish a message to an output connector", param={Object.class, String.class, Object.class})
	public IMethodProxy<Void> publish ;

	
	final public Document queryTODO()
	throws Exception
	{
		// TODO : 
		// Query String and maxrecord 
		// defined in the Bean Editor		
		return null ;
	}

	@MethodInfo(desc="The contract implementation of the application portal aspect (AppPortal) for the Console application")
	final public void console(HttpServlet srv, HttpServletRequest req, HttpServletResponse res)
	throws Exception
	{
		// TODO : provide a user interface to performe a query 
		// and show the result
	}	
	
	
	@Export
	final public Document query(String sql)
	throws Exception
	{
		Document doc = SQLXML.query(-1, sql) ;
		if(publish!=null) publish.call(this, outputName, doc) ;
		return doc;
	}
	
	@Export
	final public Document query(int maxr, String sql)
	throws Exception
	{
		Document doc = SQLXML.query(maxr, sql) ;
		if(publish!=null) publish.call(this, outputName, doc) ;
		return doc;
	}
	
	@Export
	final public Document query(String sql, Object... args)
	throws Exception
	{
		Document doc = SQLXML.query(sql, args) ;
		if(publish!=null) publish.call(this, outputName, doc) ;
		return doc;
	}
	
	@Export
	final public Document query(int maxr, String sql, Object... args)
	throws Exception
	{
		Document doc = SQLXML.query(maxr, sql, args) ;
		if(publish!=null) publish.call(this, outputName, doc) ;
		return doc;
	}			
}