/*
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.bean.xml ;
import javax.xml.transform.*;
import javax.xml.transform.stream.StreamSource;

import org.azuki.framework.annotation.*;
import org.azuki.framework.injection.IMethodProxy;
import org.azuki.framework.injection.IMethodProxy.*;
import org.jdom.*;
import org.jdom.transform.*;


/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

final public class XSLTBean
{
	final static private String outputName = "xmlout";
	
	// EventPublisher injection
	@DependencyInjectionInfo(desc="Publish a message to an output connector", param={Object.class, String.class, Object.class})
	public IMethodProxy<Void> publish ;

	private String sheet = null ;
	
	@MethodInfo(desc="Initializer contract implementation. Called at the framework initialization. Must not be called by others means")
	final public void postCreate(Element lmen)
	throws Exception
	{
		// TODO : get parameers
		sheet = "todo";
	}	
	
	@Export
	final public Document transform(Document doc)
	throws Exception
	{
        Transformer transformer = TransformerFactory.newInstance().newTransformer(new StreamSource(sheet));

        JDOMResult res = new JDOMResult();

        transformer.transform(new JDOMSource(doc), res);

        Document out = res.getDocument() ;

        if(publish!=null) publish.call(this, outputName, out) ;
		return out;
	}
}