/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.action ;

import java.awt.event.ActionListener;

import javax.swing.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public class ActionFactory
{
	final static public Action create(String name, ActionListener al)
	{
		return create(name, name, al) ;
	}
	
	final static public Action create(String name, Icon icon, ActionListener al)
	{
		return create(name, name, icon, al) ;
	}
	
	final static public Action create(String name, String label, ActionListener al)
	{
		return create(name, label, null, al) ;
	}
	
	final static public Action create(String name, String label, Icon icon, ActionListener al)
	{
		return create(name, label, icon, null, al) ;
	}
	
	final static public Action create(String name, String label, Icon icon, KeyStroke keyStroke, ActionListener al)
	{
		return create(name, label, icon, label, keyStroke, al) ;
	}
	
	final static public Action create(String name, String label, Icon icon, String desc, KeyStroke keyStroke, ActionListener al)
	{
		ActionImpl impl = new ActionImpl(name, label, icon, desc, keyStroke) ;
		if(al!=null) impl.addActionListener(al) ;
		return impl ;
	}
}