/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.action ;

import javax.swing.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

final public class Actions
{
	final static public String getActionCommand(Action action)
	{
		return getActionProperty(action, Action.ACTION_COMMAND_KEY, String.class) ;
	}
	
	final static public String getLabel(Action action)
	{
		return getActionProperty(action, Action.NAME, String.class) ;
	}
	
	final static public Icon getIcon(Action action)
	{
		return getActionProperty(action, Action.SMALL_ICON, Icon.class) ;
	}
	
	final static public Icon getLargeIcon(Action action)
	{
		return getActionProperty(action, Action.LARGE_ICON_KEY, Icon.class) ;
	}
	
	final static public KeyStroke getAcceleratorKey(Action action)
	{
		String kstk = getActionProperty(action, Action.ACCELERATOR_KEY, String.class) ;
		return KeyStroke.getKeyStroke(kstk) ;
	}
	
	final static public <T> T getActionProperty(Action action, String name, Class<T> clas)
	{
		Object val = action.getValue(name) ;
		return val==null ? null : clas.cast(val) ;
	}
}