/*
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.console.html.renderer;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

final public class HorizontalAlignCellRenderer implements TableCellRenderer
{
	final static public String ALIGN_CENTER		= "center" ;
	final static public String ALIGN_LEFT 		= "left" ;
	final static public String ALIGN_RIGHT 		= "right" ;
	final static public String ALIGN_JUSTIFY	= "justify" ;
	
	final private String algn ;
	
	public HorizontalAlignCellRenderer(String algn)
	{
		this.algn = algn ;
	}
	
	@Override
	public String render(Object t)
	{
		StringBuilder bdr = new StringBuilder() ;
		bdr.append("<div") ;
		bdr.append(" width=\"100%\"") ;
		bdr.append(" align=\"").append(algn).append("\"") ;
		bdr.append(">") ;
		bdr.append(String.valueOf(t)) ;
		bdr.append("</div>") ;
		
		return bdr.toString() ;
	}
}