/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.console.renderer;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public class MinuteRenderer
{
	final static public String get(int time)
	{	
		return get(new Integer(time)) ;
	}
	
	final static public String get(long time)
	{	
		return get(new Long(time)) ;
	}

	final static public String get(Number time)
	{	
		long t = time.longValue() ;
		
		int m = (int)(t / 60000) ;
		t -= m*60000 ;
		int s = (int)(t / 1000) ;
		t -= s*1000 ;
		int ms = (int)t;
		
		StringBuffer sb = new StringBuffer();
		if( m < 10 )	sb.append('0');
		sb.append(m) ;
		sb.append('m');
		if( s < 10 )	sb.append('0');
		sb.append(s) ;
		sb.append('s') ;
		if( ms < 100 )	sb.append('0');
		if( ms < 10 )	sb.append('0');
		sb.append(ms) ;
		
		return sb.toString() ;
	}

}