package org.azuki.common.dag;


public class Node<T>
{
	final public String key ;
	final public T      obj ;
	
	public Node(String key, T obj)
	{
		this.key = key ;
		this.obj = obj ;
	}
	
	final public String getKey() { return key; }
	final public T getObject()   { return obj; }

	@Override
	final public String toString()	{ return key ;	}

	@Override
	final public int hashCode() { return key.hashCode(); }

	@Override
	final public boolean equals(Object node)
	{
		if (this == node) return true ;
		if (node == null) return false ;
		if (Node.class != node.getClass()) return false;
		if(key.equals(((Node)node).key))   return true ;
		return false ;
	}
}
