/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.editor.jdom;

import java.awt.*;

import javax.swing.JPanel;
import javax.swing.text.JTextComponent;

import org.jdom.Attribute;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
public class JDOMCheckBoxPanel extends JPanel
{
	private JDOMCheckBox check;
	private boolean ewc= true;
	
	public JDOMCheckBoxPanel(String label, String yes, String no)
	{
		super(new BorderLayout());
		try
		{
			check = new JDOMCheckBox(yes,no);
			check.setText(label);
			add(check, BorderLayout.NORTH);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	
	final public void setAttribute(Attribute t)
	{
		check.setAttribute(t);
	}

	final public void setEnabledWhenCheck(boolean b)
	{ this.ewc = b ; }
	
	// editable ou non
	final public void setContentEnabled(boolean b)
	{ setContentEnabled(this, !b^ewc) ; }
	
	final protected void setContentEnabled(JPanel cont, boolean b)
	{
		for(int i=0 ; i<cont.getComponentCount() ; i++)
		{
			Component c = cont.getComponent(i) ;
			if(c instanceof JPanel)
				setContentEnabled((JPanel) c, b) ;
			else if(c instanceof JTextComponent)
				((JTextComponent) c).setEditable(b) ;
			else
				c.setEnabled(b) ;
		}
//		cont.setEnabled(b) ;
	}}
