/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.editor.page;

import java.awt.BorderLayout;
import java.util.List;

import org.azuki.common.editor.*;
import org.azuki.common.editor.jdom.JDOMAttributeField;
import org.azuki.common.widget.JFormPanel;
import org.jdom.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
public class FormPage extends Page
{
	/*
	 * <para>
	 * 	 <row name="myName" desc="myLabel" valu="myValue"/>
	 * </para>
	 */
	
	private JFormPanel form ;
	
	/*
	 * Page
	 */
	@Override
	@SuppressWarnings("unchecked")
	public void init(IEditorContext ectx, Element lmen)
	{
		if(lmen==null) return ;
		
		form = new JFormPanel() ;
		
		List<Element> list = lmen.getChildren(TagCommon.ROW) ;
		
		for(Element e : list)
		{
			Attribute attr = e.getAttribute(AttrCommon.VALU) ;
			JDOMAttributeField value = new JDOMAttributeField(attr) ;
			
			form.addField(value, e.getAttributeValue(AttrCommon.DESC)) ;
		}
		
		setLayout(new BorderLayout()) ;
		add(form, BorderLayout.NORTH) ;
	}
}