/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.editor.pointcut;

import java.util.*;

import org.azuki.common.editor.*;
import org.azuki.common.editor.basic.AbstractEditor;
import org.azuki.framework.aop.IContract.Selection;
import org.jdom.Element;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
abstract public class AbstractPointcutEditor extends AbstractEditor<IPointcutEditorContext> implements IPointcutEditor
{
	private List<Element> flds ;
	private List<Element> mths ;
	
	/*
	 * AbstractEditor
	 */
	@Override
	protected void init()
	{
		super.init() ;
		
		flds = new ArrayList<Element>(context.getSelectedFields()) ;
		mths = new ArrayList<Element>(context.getSelectedMethods()) ;
		
		if(context.getFieldSelection()!=Selection.NONE)		initFields(flds) ;
		if(context.getMethodSelection()!=Selection.NONE) 	initMethods(mths) ;
	}
	
	/*
	 * Abstract methods
	 */
	abstract public void initFields(List<Element> flds) ;
	abstract public void initMethods(List<Element> mths) ;
	
	/*
	 * IPointcutEditor
	 */	
	public Collection<Element> getFields()
	{
		return flds ;
	}
	
	public Collection<Element> getMethods()
	{
		return mths ;
	}
}