/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.widget.field ;

import org.azuki.common.widget.document.filter.*;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

@SuppressWarnings("serial")
public class JStringField extends AbstractTextField
{
	final static private int defaultColumns = 15 ;
	
	public enum Case{upper, lower, ignore}
	
	public JStringField()
	{
		this(Case.ignore) ;
	}
	
	public JStringField(String text)
	{
		this(text, Case.ignore) ;
	}
	
	public JStringField(Case caseMode)
	{
		this(null, caseMode) ;
	}
	
	public JStringField(String text, Case caseMode)
	{
		this(text, defaultColumns, caseMode) ;
	}
	
	public JStringField(String text, int column, Case caseMode)
	{
		super(text, column) ;
		
		if(caseMode==Case.upper) 		addFilter(new StringUppercaseFilter()) ;
		else if(caseMode==Case.lower) 	addFilter(new StringLowercaseFilter()) ;
	}
}