/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.common.widget.jdom ;

import java.util.Comparator;

import org.jdom.Element;

/**
 * @author Yoann Perrin (yoann.perrin@gmail.com)
 */

public class JDOMElementComparator implements Comparator<Element>
{
	final private String[] attrs ;
	
	public JDOMElementComparator(String... attrs)
	{
		this.attrs = attrs ;
	}
	
	// Comparator
	final public int compare(Element o1, Element o2)
	{
		if(o1==null && o2==null) return 0 ;
		if(o1==null) return -1 ;
		if(o2==null) return 1 ;
		
		for(String attr : attrs)
		{
			String val1 = o1.getAttributeValue(attr, "") ;
			String val2 = o2.getAttributeValue(attr, "") ;
			
			int comp = val1.compareTo(val2) ;
			if(comp!=0) return comp ;
		}
		
		return -1 ;
	}
}