/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.framework.bean;

import java.util.Collection;

import org.azuki.framework.Framework;
import org.azuki.framework.aop.IPointcut;

/**
 *   @author Robert Bakic (robert.bakic@gmail.com)
 */

final public class Bean
{	
	final static private Impl imp ;
	static	{ imp = Framework.getBeanImpl() ; }

	
	// Aspect ID !
	final static public Collection<IPointcut> getPointcuts(Integer aspid)
	{
		return imp.getPointcuts(aspid) ;
	}	

	// Aspect ID !
	final static public Collection<IPointcut> getPointcuts(String name)
	{
		return imp.getPointcuts(name) ;
	}	
	
	
	final static public boolean isBean(Object obj)
	{
		return imp.isBean(obj) ;
	}
	
	// Retrieves all instances metadata
	final static public Collection<IMetadata> search(String name)
	{
		return search(name, null) ;
	}

	final static public Collection<IMetadata> search(String name, String labl)
	{
		return imp.search(name, labl) ;
	}
//
	final static public IMetadata searchFirst(String name)
	{
		return searchFirst(name, null) ;
	}

	final static public IMetadata searchFirst(String name, String labl)
	{
		return imp.searchFirst(name, labl) ;
	}
	
	final static public IMetadata getMetadata(Object bean)
	throws Exception
	{
		return imp.getMetadata(bean) ;
	}

	final static public IMetadata getMetadata(Integer bid)
	throws Exception
	{
		return imp.getMetadata(bid) ; 
	}
	
////
	public interface Impl
	{
		public boolean isBean(Object obj) ;
		
		public Collection<IMetadata> search(String name, String labl) ;
		public IMetadata searchFirst(String name, String labl) ;
		
		public IMetadata getMetadata(Object bean) throws Exception ;
		public IMetadata getMetadata(Integer bid) throws Exception ;		

		public Collection<IPointcut> getPointcuts(Integer aspid) ;		
		public Collection<IPointcut> getPointcuts(String name) ;
	}	
}