/*
 *   Created the 2 April 2006
 *
 *   Azuki Framework
 *   Copyright 2006 the original author or authors.
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *   
 *   Contact : support@azuki-framework.org
 */

package org.azuki.framework.object ;

import java.util.Map;

import org.azuki.framework.Framework;



/**
 * @author Robert Bakic (robert.bakic@gmail.com)
 */

public class Locator
{
	final static private Impl imp ;
	static	{ imp = Framework.getLocatorImpl(); }
	
	// Object Factory usely defined by the framework implementation 
	final static public String OBJECT_CONTEXT      = "Context" ;     // Use ThreadContext !
	final static public String OBJECT_COMMAND      = "Command" ;     // Use Command !
	final static public String OBJECT_METHOD_PROXY = "MethodProxy" ; // Use Locator
	
	// Add object Lifecycle ?
	final static public IObjectFactory getObjectFactory(String objectype)
	{
		return imp.getObjectFactory(objectype) ;
	}
	
	final static public void addObjectFactory(String objectype, IObjectFactory fact)
	{
		imp.addObjectFactory(objectype, fact) ;
	}

	
	// TODO : remove, here because console at wrong place (bean-context)
	final static public Map<String, IObjectFactory> getAllObjectFactory()
	{
		return imp.getAllObjectFactory() ;
	}

	
	// Getters with object creation if not bound
	final static public Object create(String objectype, Object... args)
	throws Exception
	{
		return imp.create(objectype, args) ;
	}

	public interface Impl
	{
		public void addObjectFactory(String objectype, IObjectFactory fact) ;
		
		public IObjectFactory getObjectFactory(String objectype) ;
		
		public Map<String, IObjectFactory> getAllObjectFactory() ;
		
		public Object create(String objectype, Object... args)
		throws Exception ;
	}	
}